<?php
namespace Frontend\Controller;

use Common\Data\StateData as SD;
use Frontend\Controller\FrontendController;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\DomainModel;
use Frontend\Model\MemberModel;
use Frontend\Model\ProductModel;

/**
 * 域名
 * @date: 2016年10月25日 下午3:51:53
 * @author: Lyubo
 */
class DomainController extends FrontendController{
	public function _initialize(){
		parent::_initialize();
	}

	/**
	 * 获取该用户所有域名业务
	 * @date: 2016年10月25日 下午4:38:44
	 * @author: Lyubo
	 */
	public function domainlist(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$keyword = request()['select'] ? request()["select"] : "";
		$dm = new DomainModel();
		$where = $dm->conver_par();
		$order = I("get.order");
		$info = $dm->get_domain_business_list($where,10,$order,GD::PTYPE_DOMAIN);
		$this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"keyword" => $keyword]);
		$this->display();
	}

	/**
	 * 修改备注
	 * @date: 2016年10月27日 上午11:23:22
	 * @author: Lyubo
	 * @param: remark，business_id
	 * @return boolean
	 */
	public function remark(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$dm = new DomainModel();
		$result = $dm->remark_edit();
		if($result){
			$data = "ok";
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

	/**
	 * 跳转中国数据控制面板
	 * @date: 2016年10月29日 下午2:50:07
	 * @author: Lyubo
	 * @param: $business_id
	 * @return ajax
	 */
	public function panel(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$dm = new DomainModel();
		$result = $dm->domain_panel();
		if($result["code"] == '0'){
			$data["status"] = "ok";
			$data["url"] = $result['info']["ym"];
			$this->ajaxReturn($data,'json');
		}else{
			$data = "fail";
			$this->ajaxReturn($data,'json');
		}
	}

	/**
	 * 域名页面
	 * @date: 2016年11月20日 下午3:16:40
	 * @author: Lyubo
	 */
	public function domain(){
		$dm = new DomainModel();
		$product = $dm->domain_product();
		$default_domain = $dm->get_default_domain();
		$this->assign([
			'endomain' => $product['endomain'],
			'cndomain' => $product['cndomain'],
			'domian_list' => array_merge($product['endomain'],$product['cndomain']),
			'default_domain' => $default_domain
		]);
		$this->display();
	}

	/**
	 * 域名查询
	 * @date: 2016年11月20日 下午1:41:42
	 * @author: Lyubo
	 * @param: $domain,$suffix   域名参数，域名后缀
	 * @return array
	 */
	public function domain_query(){
		$data = request();
		$domain_name = $data['domain'];
		if(empty($domain_name)){
			$domain_name = "";
		}
		$dm = new DomainModel();
		$domain_type = $data["domain_type"];
		if(!IS_POST || empty($domain_name)){
			$domain_type = $domain_type ? $domain_type : "endomain";
			$product = $dm->domain_product();
			$domain_config = WebSiteConfig(SD::SYS_DEFAULT_DOMAIN);
			$default_domain = explode(",",$domain_config["default_domain"]);
			$this->assign([
				"domain_type" => $domain_type,
				"domain_name" => $domain_name,
				'endomain' => $product['endomain'],
				'cndomain' => $product['cndomain'],
				"default_domain" => $default_domain
			]);
			$this->display();die;
		}
		$domain_id = $data['domain_id']+0;
		if(empty($domain_id)){
			$this->error('请选择域名后缀',U('domain/domain'));
		}
		if($domain_type == "cndomain"){
			if(!checkCnDomainName($domain_name)){
				$msg = '中文域名"中只能包含中文、字母、数字和"-"字符，不能以"-"字符开头或结束，至少需要含有一个中文文字，最多不超过20个字符!';
				$url = U('domain/domain_query');
				$this->error($msg,$url);
			}
			$product_type = 10;
		}elseif($domain_type == "endomain"){
			if(!checkEnDomainName($domain_name)){
				$msg = '"英文域名"中只能包含字母、数字和"-"字符！并且不能以"-"字符开头、结尾！';
				$url = U('domain/domain_query');
				$this->error($msg,$url);
			}
			$product_type = 9;
		}else{
			if(preg_match("/[\x7f-\xff]/",$domain_name)) {
				if(!checkCnDomainName($domain_name)){
					$msg = '中文域名"中只能包含中文、字母、数字和"-"字符，不能以"-"字符开头或结束，至少需要含有一个中文文字，最多不超过20个字符!';
					$url = U('domain/domain_query');
					$this->error($msg,$url);
				}
				$domain_type = "cndomain";
				$product_type = 10;
			}else{
				if(!checkEnDomainName($domain_name)){
					$msg = '"英文域名"中只能包含字母、数字和"-"字符！并且不能以"-"字符开头、结尾！';
					$url = U('domain/domain_query');
					$this->error($msg,$url);
				}
				$domain_type = "endomain";
				$product_type = 9;
			}
		}
		$product_list = $dm->doamin_query($domain_type,$product_type,$domain_name,$domain_id);
		if(!is_array($product_list)){
			$messge = business_code($product_list);
			$url = U('domain/domain_query');
			$this->error($messge,$url);
		}else{
			$product = $dm->domain_product();
			$domain_config = WebSiteConfig(SD::SYS_DEFAULT_DOMAIN);
			$default_domain = explode(",",$domain_config["default_domain"]);
			$this->assign([
				"domain_type" => $domain_type,
				"domain_name" => $domain_name,
				'endomain' => $product['endomain'],
				'cndomain' => $product['cndomain'],
				"default_domain" => $default_domain,
				"product_list" => $product_list
			]);
			$this->display();
		}
	}

	/**
	 * 域名查询ajax
	 * @date: 2018年4月11日 上午11:15:05
	 * @author: Lyubo
	 * @param: state
	 */
	public function check_domain(){
		if(!IS_AJAX || !IS_POST){
			redirect(U('domain/domain_query'),0,'');die();
		}
		$data = request();
		$domain_name = $data["domain_name"];
		$domain_id = $data["product_id"];
		$dm = new DomainModel();
		$product = new ProductModel();
		$domain_product = $product->get_product($domain_id);
		if(!$domain_product){
			$this->error("产品查询失败！","",true);
		}
		$domain_type = $domain_product["api_ptype"];
		$product_type = $domain_product["product_type_id"];
		$product_list = $dm->doamin_query($domain_type,$product_type,$domain_name,$domain_id);
		if(!is_array($product_list)){
			$messge = business_code($product_list);
			$this->error($messge,"",true);
		}else{
			$is_reg = $product_list["is_reg"];
			$this->assign(["product_list" => $product_list]);
			$html = $this->fetch("search_all");
			$info["is_reg"] = $is_reg;
			$this->success($html,"",$info);
		}
	}

	/**
	 * 域名注册
	 * @date: 2016年11月24日 下午1:41:38
	 * @author: Lyubo
	 * @param: $product_id,$domain,$suffix
	 * @return boolean
	 */
	public function domainRegister(){
		$data = request(true);
		if(!session('?user_id')){
			session('backward',__SELF__);
			redirect(U('Login/login'),0,'');die();
		}
		$dm = new DomainModel();
		$product = new ProductModel();
		if(IS_POST){
			//封装联系人参数
			$contact ["dwmc"] = $data["dwmc"];
			$contact ["dwmcYW"] = trim($data["dwmcYW"]);
			$contact ["zjhm"] = $data["zjhm"];
			$contact ["zcrX"] = $data["zcrX"];
			$contact ["zcrM"] = $data["zcrM"];
			$contact ["zcrGJ"] = $data["zcrGJ"];
			$contact ["zcrSF"] = $data["zcrSF"];
			$contact ["zcrCS"] = $data["zcrCS"];
			$contact ["zcrDZ"] = trimall($data["zcrDZ"]);
			$contact ["zcrDZ2"] = trimall($data["zcrDZ2"]);
			$contact ["zcrYZBM"] = $data["zcrYZBM"];
			$contact ["zcrYX"] = $data["zcrYX"];
			$contact ["zcrDH"] = $data["zcrDH"];
			$contact ['zcrCZ'] = $data['zcrDH'];
			//验证联系人信息
			$var_code = $this->domain_var_contact($contact,$data);
			if($var_code != -1){
				$message = business_code($var_code);
				$this->error($message,"",true);
			}
			$api_type = $data["api_type"];
			$price = $data["price"];
			$result = $dm->domain_register($data["product_id"],$data['domain'],session("user_id"),$price,'1',$contact,$api_type);
			$message = business_code($result);
			if($result == -1){
				$this->success("域名注册成功，你可以在[会员中心]查看订单信息和域名信息",U('domain/domainlist'));
			}else{
				$this->error($message,U('domain/domainRegister',[
					'product_id' => $data['product_id'],'domain' => $data['domain']
				]));
			}
		}else{
			$api_type = $data["api_type"];
			if($api_type == 1 || $api_type == 100012){
				$api_type = 1;
			}else{
				$api_type = 5;
			}
			$buy_price = $product->get_product_price_list($data['product_id'],SD::STATE_BUY,$api_type);
			$renewals = $product->get_product_price_list($data['product_id'],SD::STATE_RENEWALS,$api_type);
			if(!$buy_price[0]){
				$this->error("该域名暂时不能注册！");
			}
			$api_ptype = $data["api_ptype"];
			if($api_ptype == "cndomain"){
				$product_type_id = 10;
			}else{
				$product_type_id = 9;
			}
			$discount = 1;
			if(session('?user_id')){
				$user = new MemberModel();
				$user_id = session('user_id');
				$user_level = $user->get_user_level($user_id,$product_type_id);
				if($user_level["discount"] > 0){
					$discount = $user_level["discount"];
				}
			}
			$buy_price = $buy_price[0];
			$price1["api_type"] = $buy_price["api_type"];
			$price1["product_price"] = number_format(ceil($buy_price["product_price"]),2,".","");
			$price1["year"] = 1;
			if(!$renewals[0]){
				$price_list[] = $price1;
			}else{
				$renewals = $renewals[0];
				$price_list[] = $price1;
				$price3["api_type"] = $buy_price["api_type"];
				$price3["product_price"] = number_format(ceil(($buy_price["product_price"] + $renewals["product_price"] * 2)*$discount),2,".","");
				$price3["year"] = 3;
				$price_list[] = $price3;
				$price5["api_type"] = $buy_price["api_type"];
				$price5["product_price"] = number_format(ceil(($buy_price["product_price"] + $renewals["product_price"] * 4)*$discount),2,".","");
				$price5["year"] = 5;
				$price_list[] = $price5;
				$price10["api_type"] = $buy_price["api_type"];
				$price10["product_price"] = number_format(ceil(($buy_price["product_price"] + $renewals["product_price"] * 9)*$discount),2,".","");
				$price10["year"] = 10;
				$price_list[] = $price10;
			}
			$result = $dm->show_domain_register(session("user_id"),$data);
			if(!is_array($result)){
				$msg = business_code($result);
				$this->error($msg,U('domain/domain'));
			}
			$result['product_price_list'] = $price_list;
			$this->assign("data",$data);
			$this->assign("result",$result);
			$this->display("Domain/domainRegister");
		}
	}

	/**
	 * 验证联系人信息
	 * @date: 2016年11月27日 上午11:54:11
	 * @author: Lyubo
	 * @param $contact
	 * @return int
	 */
	public function domain_var_contact($contact,$data){
		//单位名称正则表达式
		$regDWMC = "/^(([\x{4e00}-\x{9fa5}]+\（[\x{4e00}-\x{9fa5}]+\）[\x{4e00}-\x{9fa5}]*)|([\x{4e00}-\x{9fa5}])){2,25}$/u";
		//中文正则表达式
		$regZW = "/^[\x{4e00}-\x{9fa5}]{1,2}$/u";
		// 数字正则表达式
		$regSZ = "/[0-9]{6}/";
		// 手机正则表达式
		$regDH = "/1[0-9]{10}/";
		// 通讯地址英文正则表达式
		$regDZ2 = "/[a-zA-Z0-9]{6,64}/";
		// 邮箱正则表达式
		$regYX = "/[A-Za-z0-9]+@([_A-Za-z0-9]+\\.)+[A-Za-z0-9]{2,3}/";
		// 单位名称只能为中文字符，且长度<2
		if(strlen($contact ["dwmc"]) < 2 || !preg_match($regDWMC,str_replace(" ","",$contact ["dwmc"]))){
			return -18;
		}
		// 英文单位名称只能为字母数字,且长度为3-200
		if(!preg_match("/[a-zA-Z]{3,200}/",$contact ["dwmcYW"])){
			return -19;
		}
		// 注册人姓只能为中文
		if(!preg_match($regZW,$contact ["zcrX"])){
			return -20;
		}
		// 注册人名只能为中文
		if(!preg_match($regZW,$contact ["zcrM"])){
			return -21;
		}
		// 注册人国家只能为中国
		if($contact ["zcrGJ"] != "中国"){
			return -22;
		}
		//证件号码为1-30位
		if(strlen($contact["zjhm"]) == 0 || strlen($contact["zjhm"]) > 30){
			return -45;
		}
		// 注册人地址英文只能为数字字母，且长度6-64
		if(!preg_match($regDZ2,$contact ["zcrDZ2"])){
			return -23;
		}
		// 注册人邮政编码只能为数字，长度为6
		if(!preg_match($regSZ,$contact["zcrYZBM"]) || strlen($contact["zcrYZBM"]) != 6 || $contact["zcrYZBM"] == 0){
			return -24;
		}
		// 注册人电话(手机号码)
		if(!preg_match($regDH,$contact["zcrDH"])){
			return -25;
		}
		// 注册人邮箱错误
		if(!preg_match($regYX,$contact["zcrYX"])){
			return -27;
		}
		$user_id = session("user_id");
		$product_id = $data["product_id"];
		$domain_type = $data["api_ptype"];
		$domain = $data["domain"];
		//获取域名产品信息
		$product = new ProductModel();
		$info = $product->get_product($product_id);
		if(empty($info)){
			return -2;
		}
		$dm = new DomainModel();
		$request = $dm->check_domain($domain_type,$domain,$product_id);
		if($request !== -1){
			return $request;
		}
		return -1;
	}

	/**
	 * 域名续费
	 * @date: 2016年12月3日 上午11:24:55
	 * @author: Lyubo
	 * @param: domain_id
	 * @return business_code
	 */
	public function domain_renewals(){
		if(!session('?user_id')){
			redirect(U('Login/login'),0,'');die();
		}
		$domain = new DomainModel();
		$product = new ProductModel();
		$data = request();
		$domain_id = $data['domain_id'];
		$member_id = session("user_id");
		if(IS_POST){
			$renewals_time = $data['renewalstime'];
			/*域名续费*/
			$code = $domain->doamin_renewals($domain_id,$member_id,$renewals_time);
			$message = business_code($code);
			if($code == -1){
				$this->success("域名续费成功，你可以在[会员中心]查看域名信息",U('domain/domainlist'));
			}else{
				$this->error($message,U('domain/domainlist'));
			}
		}else{
			if(empty ($domain_id) && !is_numeric($domain_id)){
				$msg = "编号不存在，或编号错误";
				$this->error($msg,U('domain/domainlist'));
			}
			$domain_info = $domain->domain_renewals_info($domain_id,$member_id);
			$discount = 1;
			$user = new MemberModel();
			$user_level = $user->get_user_level($member_id,$domain_info["product_type_id"]);
			if($user_level["discount"] > 0){
				$discount = $user_level["discount"];
			}
			$product_price_list = null;
			if(!empty($domain_info)){
				$condition['type'] = ["eq",SD::STATE_RENEWALS];
				$condition['api_type'] = ["eq",$domain_info["api_type"]];
				$product_price_list = $product->get_product_price_buy_time($domain_info ["product_id"],$condition);
				$product_price_list["product_price"] = number_format(ceil($product_price_list["product_price"]*$discount),2,".","");
				$domain_info['product_price_list'] = $product_price_list;
			}
			$this->assign($domain_info);
			$this->display();
		}
	}

	/**
	 * 域名同步
	 * @date: 2017年1月12日 下午5:02:48
	 * @author: Lyubo
	 * @param: variable
	 */
	public function memberSync(){
		if(!session('?user_id')){
			$this->error("请先登录！",U('Login/login'),true);die();
		}
		$data = request();
		$yw_id = $data['business_id'] + 0;
		$url = U('domain/domainlist');
		$dm = new DomainModel();
		$dmRespository = new \Common\Respository\DomainRespository($dm);
		$result = $dmRespository->DomainBusinessSynchronizing($yw_id);
		if($result){
			$this->success("同步业务信息成功",$url,true);
		}else{
			$this->error("同步业务信息失败-".$dmRespository->model()->getError(),$url,true);
		}
	}

	/**
	 * 批量同步域名
	 * @date: 2018年4月16日17:07:09
	 * @author: Guopeng
	 * @param: $business_id,$ptype
	 */
	public function SyncBatch(){
		if(!session('?user_id')){
			$this->error("请先登录！",U('Login/login'),true);die();
		}
		$member_id = session("user_id")+0;
		$data = request();
		$yids = $data["yids"];
		$dm = new DomainModel();
		$dmRespository = new \Common\Respository\DomainRespository($dm);
		if(!is_array($yids)){
			$this->error("同步业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		foreach($yids as $yid){
			$all++;
			$info = $dm->domain_renewals_info($yid,$member_id);
			if(!$info){
				$this->error("同步业务信息失败!","",true);
			}
			$yw_id = $info['api_bid'];
			$result = $dmRespository->DomainBusinessSynchronizing($yw_id);
			if($result){
				$ok++;
			}else{
				$err++;
			}
		}
		$this->success("共同步<font color='red'>".$all."</font>个域名，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
	}
}