<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Common\Aide\JumpAide;
use Frontend\Model\DomainModel;
use Frontend\Model\VpsModel;
use Frontend\Model\VirtualhostModel;
use Frontend\Model\FastvpsModel;
use Frontend\Model\CloudspaceModel;
use Frontend\Model\CloudserverModel;
use Frontend\Model\ClouddbModel;

class JumpController extends FrontendController{

    protected $aide = null;

    public function _initialize(){
        parent::_initialize();
        if(!session('?user_id')){
            redirect(U('Login/login'),0,'');
            die();
        }
        //加载跳转helper
        $this->aide = new JumpAide();
    }

    /**
     * 公共跳转自助管理平台
     * @date: 2016年10月26日 下午3:32:50
     * @author: Lyubo
     */
    public function user_call_self(){
        $api_name = $_GET['api_name'];
        $input_name = $_GET['input_name'];
        $business_id = $_GET['business_id'];
        $business_mark = $_GET['business_mark'];
        $result = "";
        if($input_name == "vps"){//vps
            $vps_business = new VpsModel();
            $result = $vps_business->get_business_one($business_id);
        }elseif($input_name == "usahost" || $input_name == "hkhost" || $input_name == "host" || $input_name == "dedehost" || $input_name == "cloudVirtual"){//美国，香港，国内，云虚拟主机
            $host_business = new VirtualhostModel();
            $result = $host_business->get_business_one($business_id);
        }elseif($input_name == "fastcloudvps"){//快云
            $fastvps_business = new FastvpsModel();
            $result = $fastvps_business->get_business_one($business_id);
        }elseif($input_name == "cloudspace"){//云空间
            $cloudspace_business = new CloudspaceModel();
            $result = $cloudspace_business->get_business_one($business_id);
        }elseif($input_name == "cloudserver"){//快云服务器
            $cloudserver_business = new CloudserverModel();
            $result = $cloudserver_business->get_api_bid_one($business_id);
        }elseif($input_name == "clouddb"){//快云数据库
            $clouddb_business = new ClouddbModel();
            $result = $clouddb_business->get_api_bid_one($business_id);
        }
        if($result){
            //1.获取服务码
            $service_code = $this->aide->get_service_code($input_name,$api_name,$business_id,$business_mark,$result["access"]);
            //2.如果服务吗不为空
            if(!empty($service_code)){
                //跳转去自助管理平台
                $res = $this->aide->jump_to_ssp($service_code,$result["access"]);
                if($res){
                    echo $res;die;
                }
            }
            //如果有错误，获取错误信息
            $info = $this->aide->getInfo();
            //$this->self_manager($input_name,$api_name,$business_id,$business_mark);
        }else{
            session(null);
        }
        $error_info = empty($info) ? "该业务不属于该会员，请重新登陆！" : $info;
        $this->error($error_info,U('/'));
    }

	/**
	 * 公共获取产品服务码
	 * @date: 2018年2月5日10:11:49
	 * @author: Guopeng
	 */
    public function get_sevice_code(){
		$data = request();
		$api_name = $data['api_name'];
		$input_name = $data['input_name'];
		$business_id = $data['business_id'];
		$business_mark = $data['business_mark'];
		$result = "";
		if($input_name == "vps"){//vps
			$business = new VpsModel();
			$result = $business->get_business_one($business_id);
			$yid = $result["id"];
		}elseif($input_name == "usahost" || $input_name == "hkhost" || $input_name == "host" || $input_name == "dedehost" || $input_name == "cloudVirtual"){//美国，香港，国内，云虚拟主机
			$business = new VirtualhostModel();
			$result = $business->get_business_one($business_id);
			$yid = $result["id"];
		}elseif($input_name == "fastcloudvps"){//快云
			$business = new FastvpsModel();
			$result = $business->get_business_one($business_id);
			$yid = $result["id"];
		}elseif($input_name == "cloudspace"){//云空间
			$business = new CloudspaceModel();
			$result = $business->get_business_one($business_id);
			$yid = $result["id"];
		}elseif($input_name == "cloudserver"){//快云服务器
			$business = new CloudserverModel();
			$result = $business->get_api_bid_one($business_id);
			$yid = $result["id"];
		}elseif($input_name == "clouddb"){//快云数据库
			$business = new ClouddbModel();
			$result = $business->get_api_bid_one($business_id);
			$yid = $result["id"];
		}
		if($result){
			//获取服务码
			$service_code = $this->aide->get_service_code($input_name,$api_name,$business_id,$business_mark,$result["access"]);
			if($service_code['code'] === 0){
				$where["user_id"] = array("eq",session("user_id"));
				$where["id"] = array("eq",$yid);
				$info["service_code"] = $service_code["info"]["serviceCode"];
				$info["service_code_psd"] = $service_code["info"]["passwd"];
				$business->where($business_id)->save($info);
				$message = "成功";
				if(IS_AJAX){
					$this->success($message,"",$service_code["info"]);
				}else{
					$this->success($message,"");
				}
			}else{
				//如果有错误，获取错误信息
				$message = $this->aide->getInfo();
				if(IS_AJAX){
					$this->error($message,"",true);
				}else{
					$this->error($message,"");
				}
			}
		}else{
			$message = "业务不存在！";
			if(IS_AJAX){
				$this->error($message,"",true);
			}else{
				$this->error($message,"");
			}
		}
    }

	/**
	 * 获取域名证书
	 * @date: 2018年2月5日10:11:49
	 * @author: Guopeng
	 */
	public function get_domain_credentials(){
		$data = request();
		$b_id = $data['b_id'];
		$domain_business = new DomainModel();
		$result = $domain_business->get_api_bid_one($b_id);
		if($result["api_type"] == 1 || $result["api_type"] == 100012){
			$api_type = 1;
			$domain_name = $b_id;
		}else{
			$api_type = 5;
			$domain_name = $result["domain_name"];
		}
		if($result){
			$credentials_url = $this->aide->get_domain_credentials($domain_name,$result["access"],$api_type);
			if($credentials_url !== false){
				$message = "成功";
				if(IS_AJAX){
					$this->success($message,"",["credentials_url"=>$credentials_url,"api_type"=>$api_type]);
				}else{
					$this->success($message,"");
				}
			}else{
				//如果有错误，获取错误信息
				$message = $this->aide->getInfo();
				if(IS_AJAX){
					$this->error($message,"",true);
				}else{
					$this->error($message,"");
				}
			}
		}else{
			$message = "业务不存在！";
			if(IS_AJAX){
				$this->error($message,"",true);
			}else{
				$this->error($message,"");
			}
		}
	}
}