<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Frontend\Model\VpsModel;

/**
 * VPS
 * @date: 2016年10月25日 下午3:51:53
 * @author: Lyubo
 */
class VpsController extends FrontendController{
    public function _initialize(){
        parent::_initialize();
        if(!session('?user_id')){
            redirect(U('Login/login'));die();
        }
    }

    /**
     * 获取用户所有VPS业务
     * @date: 2016年10月25日 下午4:42:40
     * @author: Lyubo
     * @display: $info
     */
    public function vpslist(){
		$keyword = request()['select'] ? request()["select"] : "";
        $fs = new VpsModel();
        $where = $fs->conver_par();
        $order = I("get.order");
        $info = $fs->get_vps_business_list($where,10,$order);
        $this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"keyword" => $keyword]);
        $this->display();
    }

    /**
     * 获取用户所有VPS待续费业务
     * @date: 2016年10月25日 下午4:42:40
     * @author: Lyubo
     * @display: $info
     */
    public function vpsrenew(){
		$keyword = request()['select'] ? request()["select"] : "";
        $fs = new VpsModel();
        $where = $fs->conver_par();
        $order = I("get.order");
        $info = $fs->get_vps_renew_list($where,10,$order);
        $this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"keyword" => $keyword]);
        $this->display();
    }

    /**
     * 获取列表数量和待续费业务数量
     * @date: 2017年4月11日 下午4:47:38
     * @author: Lyubo
     * @param: variable
     * @return json
     */
    public function state_count(){
        $fs = new VpsModel();
        $sum = $fs->stateCount();
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 修改备注
     * @date: 2016年10月27日 上午11:23:22
     * @author: Lyubo
     * @param: remark，business_id
     * @return json
     */
    public function remark(){
        $vps = new VpsModel();
        $result = $vps->remark_edit();
        if($result){
            $data = "ok";
            $this->ajaxReturn($data,'json');
        }else{
            $data = "fail";
            $this->ajaxReturn($data,'json');
        }
    }

    /**
     * 获取VPS业务详情
     * @date: 2017年5月24日 上午11:02:40
     * @author: Guopeng
     * @return array
     */
    public function vpsinfo(){
        if(isMobile() != "phone"){
            $this->_empty();
        }
        $fs = new VpsModel();
        $date = request();
        $vps_id = $date["yid"] + 0;
        if(empty($vps_id)){
            $this->error("业务编号错误或不存在！");
        }
        $vps_info = $fs->vps_info($vps_id);
        if(empty($vps_id)){
            $this->error("业务编号错误或不存在！");
        }
        $this->assign(["info" => $vps_info]);
        $this->display();
    }

    /**
     * VPS租赁服务协议
     * @date: 2017年5月26日 上午11:40:40
     * @author: Guopeng
     */
    public function vps_agreement(){
        if(isMobile() != "phone"){
            $this->_empty();
        }
        $this->display();
    }
    /**************************VPS业务开通***************************/
    /**
     * 开通VPS业务
     * @date: 2016年11月19日 上午10:02:37
     * @author: Lyubo
     * @param: $order_id
     */
    public function vps_open(){
        $order = new \Frontend\Model\OrderModel();
        $vps = new VpsModel();
        $open_info = request();
        $order_id = $open_info['order_id'];
        $member_id = session('user_id');
        if(is_null($order_id) || $order_id <= 0 || !is_int($order_id)){
            $msg = '订单不存在';
            $url = U('order/orderlist',['state'=>'6']);
            if(IS_AJAX){
                $this->error($msg,$url,true);
            }else{
				$this->_empty($msg,1);die;
//				$this->error($msg,$url);
            }
        }
        if(IS_POST){
            $result = $vps->vps_open($order_id,$member_id);
            $msg = business_code($result['code']);
            if($result['code'] == -1){
				//发送开通邮件
				business_sendMail('11',$result,$member_id);
                if(isMobile() == "phone"){
                    $msg = "VPS开通成功，暂时不支持手机管理产品，您可以在电脑登录[产品中心-VPS]查看VPS业务信息";
                    $url = U('order/orderinfo',["order_id"=>$order_id]);
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
                    $msg = "VPS开通成功，您可以在[产品中心-VPS]查看VPS业务信息";
                    $url = U('vps/vpslist');
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }
            }elseif($result['code'] === 0){
                if(isMobile() == "phone"){
                    $msg = "该VPS订单已经开通，暂时不支持手机管理产品，您可以在电脑登录[产品中心-VPS]查看VPS业务信息";
                    $url = U('order/orderinfo',["order_id"=>$order_id]);
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
                    $msg = "该VPS订单已经开通，您可以在[产品中心-VPS]查看VPS业务信息";
                    $url = U('vps/vpslist');
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }
            }else{
                if(IS_AJAX){
                    $this->error($msg,"",true);
                }else{
                    $this->error($msg);
                }
            }
        }else{
            //显示开通页面
            $order_info = $order->order_find($order_id);
            if($order_info ['user_id'] != $member_id || $order_info ['state'] != 6){
                if($order_info['state'] == '1'){
                    $msg = '订单状态失败，请联系客服';
                }elseif($order_info['state'] == '1'){
                    $msg = '订单已开通,请到业务列表查看业务信息';
                }else{
                    $msg = '订单不存在，或者订单错误';
                }
                $url = U('order/orderlist',['state' => '6']);
				$this->_empty($msg,1);die;
//                if(IS_AJAX){
//                    $this->error($msg,$url,true);
//                }else{
//                    $this->error($msg,$url);
//                }
            }
            $this->assign('order_info',$order_info);
            $this->display();
        }
    }
    /**************************VPS业务开通***************************/
    /**************************VPS业务续费***************************/
    /**
     * VPS业务续费
     * @author:Guopeng
     */
    function vps_renewals(){
        $user_id = intval(session("user_id"));
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_empty($msg,1);die;
//				$this->error($msg,$url);
			}
        }
        if(IS_POST){
            $order_time = $data["renewalstime"] + 0;
            $result = $vs->vps_renewals($user_id,$yw_id,$order_time);
            $msg = business_code($result);
            if($result == -1){
                $msg = "VPS续费成功，您可以在[会员中心]查看订单信息和VPS信息";
				if(IS_AJAX){
					$this->success($msg,$url,true);
				}else{
					$this->success($msg,$url);
				}
            }else{
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }
        }else{
            // 业务信息
            $result = $vs->vps_renewals($user_id,$yw_id,'',"get");
            $msg = business_code($result);
            if($result <= 0){
				$this->_empty($msg,1);die;
//                $this->error($msg,$url);
            }
            // 续费业务信息
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务续费***************************/
    /**************************VPS业务升级***************************/
    /**
     * VPS业务升级
     * @author:Guopeng
     */
    function vps_uplevel(){
        $user_id = session("user_id");
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_empty($msg,1);die;
//				$this->error($msg,$url);
			}
        }
        if(IS_POST){
            $up_product_id = $data["up_product_id"] + 0;
            if(is_null($up_product_id) || !is_numeric($up_product_id) || strpos($up_product_id,".") != false || $up_product_id <= 0){
                $msg = "产品名称错误";
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }else{
                $result = $vs->vps_upgrade($user_id,$yw_id,$up_product_id);
                $msg = business_code($result);
                if($result == -1){
                    $msg = "VPS升级成功，您可以在[会员中心]查看订单信息和VPS信息";
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
					if(IS_AJAX){
						$this->error($msg,$url,true);
					}else{
						$this->error($msg,$url);
					}
                }
            }
        }else{
            // 业务信息
            $result = $vs->vps_upgrade($user_id,$yw_id,'',"get");
            $msg = business_code($result);
            if($result <= 0){
				$this->_empty($msg,1);die;
//                $this->error($msg,$url);
            }
            // 续费业务信息
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务升级***************************/
    /**************************VPS业务增值***************************/
    /**
     * VPS业务增值
     * @author:Guopeng
     */
    function vps_appreciation(){
        $user_id = intval(session("user_id"));
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_empty($msg,1);die;
//				$this->error($msg,$url);
			}
        }
        if(IS_POST){
            $appreciation_name = $data["api_name"]; // 增值类型
            $appreciation_size = $data["app_size"] + 0; // 增值容量
            if(is_null($appreciation_size) || !is_numeric($appreciation_size) || strpos($appreciation_size,".") != false || $appreciation_size <= 0){
                $msg = "增值容量错误";
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }elseif(is_null($appreciation_name)){
                $msg = "增值类型错误";
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }else{
                $result = $vs->vps_appreciation($user_id,$yw_id,$appreciation_name,$appreciation_size);
                $msg = business_code($result);
                if($result == -1){
                    $msg = "VPS增值成功，您可以在[会员中心]查看订单信息和VPS信息";
					if(IS_AJAX){
						$this->success($msg,$url,true);
					}else{
						$this->success($msg,$url);
					}
                }else{
					if(IS_AJAX){
						$this->error($msg,$url,true);
					}else{
						$this->error($msg,$url);
					}
                }
            }
        }else{
            // 业务信息
            $result = $vs->vps_appreciation($user_id,$yw_id,'','',"get");
            $msg = business_code($result);
            if($result <= 0){
				$this->_empty($msg,1);die;
//                $this->error($msg,$url);
            }
            // 续费业务信息
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务增值***************************/
    /**************************VPS业务转正***************************/
    /**
     * VPS业务转正
     * @author:Guopeng
     */
    function vps_onformal(){
        $user_id = intval(session("user_id"));
        $vs = new VpsModel();
        $url = U('vps/vpslist');
        $data = request();
        $yw_id = $data["vps_id"] + 0;
        if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
            $msg = "业务编号为空或错误";
			if(IS_AJAX){
				$this->error($msg,$url,true);
			}else{
				$this->_empty($msg,1);die;
//				$this->error($msg,$url);
			}
        }
        if(IS_POST){
            /*主机转正*/
            $service_time = $data["service_time"] + 0;
            $result = $vs->vps_onformal($user_id,$yw_id,$service_time);
            $msg = business_code($result);
            if($result == -1){
                $msg = "VPS转正成功，您可以在[会员中心]查看VPS信息";
				if(IS_AJAX){
					$this->success($msg,$url,true);
				}else{
					$this->success($msg,$url);
				}
            }else{
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
            }
        }else{
            /*显示主机转正*/
            $result = $vs->vps_onformal($user_id,$yw_id,'','get');
            if($result <= 0){
                $msg = business_code($result);
				$this->_empty($msg,1);die;
//                $this->error($msg,$url);
            }
            $this->assign($result);
            $this->display();
        }
    }
    /**************************VPS业务转正***************************/
    /**
     * 同步业务信息
     * @date: 2016年11月29日 下午2:53:15
     * @author: Lyubo
     * @param: $yw_id,$ptype
     * @return boolean
     */
    public function memberSync(){
        $data = request();
        $yw_id = $data['business_id'] + 0;
        $ptype = $data['ptype'];
        $url = U('vps/vpslist');
        $vps = new VpsModel();
        $vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
        $result = $vpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
        if($result){
            $this->success("同步业务信息成功",$url,true);
        }else{
            $this->error("同步业务信息失败-".$vpsRespository->model()->getError(),$url,true);
        }
    }

    /**
     * 手机站VPS购买页
     * @date: 2017年5月3日 上午9:16:49
     * @author: Guopeng
     * @param:
     */
    public function vps_buy(){
        $this->_empty();
    }

	/**
	 * 批量同步业务信息
	 * @date: 2018年4月16日17:07:09
	 * @author: Guopeng
	 * @param: $business_id,$ptype
	 */
	public function SyncBatch(){
		$data = request();
		$yids = $data["yids"];
		$vps = new VpsModel();
		$vpsRespository = new \Common\Respository\VpsBusinessRespository($vps);
		if(!is_array($yids)){
			$this->error("同步业务信息失败!","",true);
		}
		$all = $ok = $err = 0;
		foreach($yids as $yid){
			$all++;
			$info = $vps->vps_info($yid);
			if(!$info){
				$this->error("同步业务信息失败!","",true);
			}
			$yw_id = $info['business_id'];
			$ptype = $info['api_ptype'];
			$result = $vpsRespository->VpsBusinessSynchronizing($yw_id,$ptype);
			if($result){
				$ok++;
			}else{
				$err++;
			}
		}
		$this->success("共同步<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
	}
}