<?php
namespace Frontend\Model;

use Common\Data\StateData as SD;
use Think\Model;
use Think\Page;

class FinancialModel extends Model{
	protected $trueTableName = 'agent_member_account';

	public function conver_par(){
		$date = request();
		$where["user_id"] = array("eq",session("user_id"));
		if(!empty($date['select'])){
			$where["note_appended"] = array("like","%".$date['select']."%");
		}
		return $where;
	}

	/**
	 * 获取该会员账户金额信息
	 * @date: 2016年11月2日 下午4:13:51
	 * @author: Lyubo
	 * @param $where
	 * @return mixed
	 */
	public function account_info($where){
		return $this->where($where)->find();
	}

	/**
	 * 函数用途描述
	 * @date: 2016年11月11日 下午2:28:24
	 * @author: Lyubo
	 * @param: $member_id
	 * @param: $balance   余额
	 * @param: $purchases 消费总额
	 * @return bool
	 */
	public function edit_member_account($member_id,$balance,$purchases){
		$where["user_id"] = array("eq",$member_id);
		$data["balance"] = $balance;
		$data["purchases"] = $purchases;
		$data["update_time"] = current_date();
		return $this->where($where)->save($data);
	}

	/**
	 * 会员交易列表
	 * @date: 2016年11月2日 下午6:13:40
	 * @author: Lyubo
	 * @param $where
	 * @param int $per_page
	 * @return array|bool
	 */
	public function tran_list($where,$per_page = 5){
		$info = [];
		if($where){
			$sum = $this->paging($where,$per_page);
			$data = $this->queryBuilder($where)->limit($sum['page']->firstRow.','.$sum['page']->listRows)->select();
			$info['count'] = $sum['count'];
			$info['show'] = $sum['page']->show();
			//对自带thinkphp分页进行替换
			$show = str_replace("<div>","",$info["show"]);
			$show = str_replace("</div>","",$show);
			$show = str_replace("span","a",$show);
			$info['page_show'] = $show;
			$info['list'] = $data;
			return $info;
		}else{
			$this->error = "查询条件为空";
			return false;
		}
	}

	/**
	 * 获取带条件的总记录数
	 * @date: 2016年10月27日 下午7:17:01
	 * @author: Lyubo
	 * @param $where
	 * @param string $order
	 * @return mixed
	 */
	function queryBuilder($where,$order = "DESC"){
		$transactions = M("member_transactions");
		return $transactions->alias('ts')
			->field("user_id,login_name,order_id,account_money,product_id,note_appended,type,create_time,recharge_type,remark,(select product_name from agent_product where id = product_id) as product_name")
			->where($where)->order("create_time ".$order);//返回带条件的总记录数
	}

	/**
	 * 公共分页
	 * @date: 2016年10月27日 下午6:07:17
	 * @author: Lyubo
	 * @param $where
	 * @param int $per_page
	 * @param $fields
	 * @return array
	 */
	public function paging($where,$per_page = 5,$fields){
		$sumpage = [];
		$count = $this->queryBuilder($where,$fields)->count();
		$Page = new Page($count,$per_page);// 实例化分页类 传入总记录数和每页显示的记录数
		$Page->setConfig('prev','上一页');
		$Page->setConfig('next','下一页');
		$Page->setConfig("first","首页");
		$Page->setConfig("last","尾页");
		$request = request();
		//分页跳转的时候保证查询条件
		foreach($request as $key => $val){
			$Page->parameter[$key] = urlencode($val);
		}
		$sumpage['page'] = $Page;
		$sumpage['count'] = $count;
		return $sumpage;
	}

	/**
	 * 会员在线冲值
	 * @date: 2016年11月3日 下午4:07:42
	 * @author: Lyubo
	 * @param $user_id
	 * @param $money
	 * @param $order_no
	 * @param $sign_type
	 * @return bool|mixed
	 */
	public function user_recharge_online($user_id,$money,$order_no,$sign_type){
		$member = new MemberModel();
		$member_where['user_id'] = ['eq',$user_id];
		$user_info = $member->get_member_info($member_where);
		$par = array(
			'user_id' => $user_id,
			'login_name' => $user_info['login_name'],
			'account_money' => $money,
			'create_time' => date('Y-m-d H:i:s'),
			'update_time' => date('Y-m-d H:i:s'),
			'order_id' => $order_no,
			'SFT_SignType' => $sign_type,
			'SFT_OrderNo' => ' ',
			'note_appended' => '用户:'.$user_info['login_name'].'在线充值：'.$money.'元',
			'state' => SD::STATE_ONLINE_TRAN_WAIT
		);
		$transaction = M("member_online_transactions");
		$result = $transaction->add($par);
		if($result !== false){
			return $result;
		}else{
			return false;
		}
	}

	/**
	 * 修改支付订单状态
	 * @date: 2016年12月8日 下午2:39:54
	 * @author: Lyubo
	 * @param $up_where
	 * @param $updata_info
	 * @return bool
	 */
	public function update_member_online($up_where,$updata_info){
		return $this->where($up_where)->save($updata_info);
	}

	public function wxpay(){
		$pay_config = WebSiteConfig(7);
		$site_config = WebSiteConfig();
		if($pay_config["pay_wx"] == 0){
			$this->error = "本站未设置微信充值功能！";
			return false;
		}
		$member = new MemberModel();
		$data = request();
		$money = round($data["money"],2);
		if($money <= 0){
			$this->error = "充值金额错误！";
			return false;
		}
		$type = $data['paymode'];
		if($type != "weixin"){
			$this->error = "参数错误！";
			return false;
		}
		$member_id = session("user_id");
		$member_where['user_id'] = ['eq',$member_id];
		$member_info = $member->get_member_info($member_where);
		if(!$member_info){
			$this->error = "会员信息获取失败！";
			return false;
		}
		//引入WxPayPubHelper
		vendor('WxPayPubHelper.WxPayPubHelper');
		$config['appid'] = $pay_config["wxpay_appid"];
		$config['mchid'] = $pay_config["wxpay_mchid"];
		$config['key'] = $pay_config["wxpay_key"];
//		$config['sslcert_path'] = './cacert/apiclient_cert.pem';
//		$config['sslkey_path'] = './cacert/apiclient_key.pem';
		//使用统一支付接口
		$unifiedOrder = new \UnifiedOrder_pub($config);
		//设置统一支付接口参数
		//设置必填参数
		$unifiedOrder->setParameter("body",$site_config["site_name"]."充值");//商品描述
		$nonce_str = create_order_no();
		$timeStamp = time();
		//自定义订单号，此处仅作举例
		$out_trade_no = $config['mchid']."$timeStamp";
		$unifiedOrder->setParameter("out_trade_no",$out_trade_no);//商户订单号
		$unifiedOrder->setParameter("total_fee",$money * 100);//总金额
		$unifiedOrder->setParameter("notify_url",$pay_config["wxpay_notify_url"]);//通知地址
		$unifiedOrder->setParameter("trade_type","NATIVE");//交易类型
		$unifiedOrder->setParameter("attach",$nonce_str);//附加数据随机字符串
		//非必填参数，商户可根据实际情况选填
//      $unifiedOrder->setParameter("time_start","XXXX");//交易起始时间
//      $unifiedOrder->setParameter("time_expire","XXXX");//交易结束时间
//      $unifiedOrder->setParameter("openid","19405");//用户标识
		//获取统一支付接口结果
		$unifiedOrderResult = $unifiedOrder->getResult();
		//商户根据实际情况设置相应的处理流程
		if($unifiedOrderResult["return_code"] == "FAIL"){
			//商户自行增加处理流程
			$this->error = "通信出错：".$unifiedOrderResult['return_msg'];
			return false;
		}elseif($unifiedOrderResult["code_url"] != NULL){
			//商户自行增加处理流程
			$par = array(
				'user_id' => $member_info["user_id"],
				'login_name' => $member_info['login_name'],
				'account_money' => $money,
				'create_time' => date('Y-m-d H:i:s'),
				'update_time' => date('Y-m-d H:i:s'),
				'order_id' => $out_trade_no,
				'SFT_SignType' => "WX",
				'SFT_OrderNo' => $nonce_str,
				'note_appended' => '用户:'.$member_info['login_name'].'在线充值：'.$money.'元',
				'state' => SD::STATE_ONLINE_TRAN_WAIT
			);
			$transaction = M("member_online_transactions");
			$result = $transaction->add($par);
			if($result !== false){
				//从统一支付接口获取到code_url
				$return["code_url"] = $unifiedOrderResult["code_url"];
				$return["out_trade_no"] = $out_trade_no;
				return $return;
			}else{
				$this->error = "充值记录生成失败！";
				return false;
			}
		}
	}
}